unit Esrodbu1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Rdonly;

type
  TForm1 = class(TForm)
    TestRODB: TCReadOnlyDB;
    PorNome: TCReadOnlyIndex;
    PorMatricula: TCReadOnlyIndex;
    PorSalario: TCReadOnlyIndex;
    CriarBanco: TButton;
    DeptoPorCod: TCReadOnlyIndex;
    EmpPorDepto: TCReadOnlyIndex;
    lab_sortw: TLabel;
    procedure CriarBancoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations  }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
    u_ordem;

type
    TEmpregado = record
        Nome: Str60;
        Matricula: longint;
        Salario: real;
        Depto: ChArr10;
        end;
    TDepartamento = record
        Codigo: ChArr10;
        Nome: Str120;
        end;

const
    BStr60: Str60 = '                                         ' +
                                                           '                  ';
    BStr120: Str120 = '                                                     ' +
            '                                                                 ';

var
    Empregado: TEmpregado;
    Departamento: TDepartamento;

{$F+}
procedure AcompanhaSort (S: string; C: SortPass; R: longint);
begin
if C = Start then
    form1.lab_sortw.caption := S + ' Incio do Sort'
else
if C = OneMore then
    form1.lab_sortw.caption := S + ' Lendo registro ' + IntToStr (R)
else
    form1.lab_sortw.caption := S + ' Fim do Sort';
Application.ProcessMessages;
end; { AcompanhaSort }
{$F-}

procedure TForm1.CriarBancoClick(Sender: TObject);
var
    RecOffset: longint;
    ScratchFile: file;
begin
CriarBanco.enabled := false;

{ Previous Arrangements }
AssignFile (ScratchFile, Testrodb.DBName);
{$I-}
Reset (ScratchFile, 1);
if (IOResult = 0) and (Application.MessageBox (
    'O arquivo do Banco de Dados j existe. Deseja sobrescrever?',
        'Confirme criao do Banco', mb_yesno + mb_iconexclamation) = idno) then
    begin
    System.Close (ScratchFile);
    Close;
    end;
{$I+}

{ Criando os Arquivos do Banco }
testrodb.CreateFiles;

{ Criando os ndices }
testrodb.AddIndex (pornome,      @StringCompare,  SizeOf (Str60));
testrodb.AddIndex (pormatricula, @LongintCompare, SizeOf (longint));
testrodb.AddIndex (porsalario,   @RealCompare,    SizeOf (Real));
testrodb.AddIndex (deptoporcod,  nil,             SizeOf (ChArr10));
testrodb.AddIndex (emppordepto,  @ChArr10Compare, SizeOf (ChArr10));

{ Gravando alguns Departamentos }
with Departamento do
    begin
    Codigo := 'Testes    ';
    Nome := Bstr120;
    Nome   := 'Departamento de Testes Operacionais';
    RecOffset := testrodb.DBWrite (departamento, sizeof (Departamento));
    Deptoporcod.AddEntry (codigo, sizeof (departamento), RecOffset);

    Codigo := 'Sumios   ';
    Nome := Bstr120;
    Nome   := 'Departamento de Trabalhos Sujos';
    RecOffset := testrodb.DBWrite (departamento, sizeof (Departamento));
    Deptoporcod.AddEntry (codigo, sizeof (departamento), RecOffset);

    Codigo := 'Contab    ';
    Nome := Bstr120;
    Nome   := 'Contabilidade e Finanas';
    RecOffset := testrodb.DBWrite (departamento, sizeof (Departamento));
    Deptoporcod.AddEntry (codigo, sizeof (departamento), RecOffset);

    Codigo := 'Produo  ';
    Nome := Bstr120;
    Nome   := 'Departamento de Produo';
    RecOffset := testrodb.DBWrite (departamento, sizeof (Departamento));
    Deptoporcod.AddEntry (codigo, sizeof (departamento), RecOffset);

    Codigo := 'Vendas    ';
    Nome := Bstr120;
    Nome   := 'Departamento de Vendas';
    RecOffset := testrodb.DBWrite (departamento, sizeof (Departamento));
    Deptoporcod.AddEntry (codigo, sizeof (departamento), RecOffset);

    Codigo := 'Presidenci';
    Nome := Bstr120;
    Nome   := 'Presidncia';
    RecOffset := testrodb.DBWrite (departamento, sizeof (Departamento));
    Deptoporcod.AddEntry (codigo, sizeof (departamento), RecOffset);
    end;

{ Agora, alguns registros de empregados }
with Empregado do
    begin
    Nome := Bstr60;
    Nome      := 'Joo Jos da Silva Xavier';
    Matricula := 3597;
    Salario   := 4500.00;
    Depto     := 'Testes    ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Antonio Alencastro Almeida Arajo';
    Matricula := 1;
    Salario   := 230.00;
    Depto     := 'Sumios   ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Jacob Gold Silverman';
    Matricula := 171;
    Salario   := 8000.00;
    Depto     := 'Contab    ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Mephistpheles Mitlogo Grego';
    Matricula := 51;
    Salario   := 130.00;
    Depto     := 'Contab    ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Moreira Franco Meu Nome  Trabalho';
    Matricula := 43;
    Salario   := 3000.00;
    Depto     := 'Produo  ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Rogria Weissmann';
    Matricula := 24;
    Salario   := 2424.24;
    Depto     := 'Produo  ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Sonia Lopes Carrillo Maia';
    Matricula := 69;
    Salario   := 6969.69;
    Depto     := 'Vendas    ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Themstocles Aristides Penfold Sobrinho';
    Matricula := 235;
    Salario   := 890.00;
    Depto     := 'Testes    ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Um Dois Tres de Oliveira Quatro';
    Matricula := 12304;
    Salario   := 1200.00;
    Depto     := 'Sumios   ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Og Mandino';
    Matricula := 1;
    Salario   := 10000.00;
    Depto     := 'Vendas    ';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Osvaldo Calistenico Pereira de Oliveira';
    Matricula := 45;
    Salario   := 15000.00;
    Depto     := 'Presidenci';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);

    Nome := Bstr60;
    Nome      := 'Oriz Merluz de Endeavour';
    Matricula := 3;
    Salario   := 280.00;
    Depto     := 'Presidenci';
    RecOffset := testrodb.DBWrite (Empregado, SizeOf (Empregado));
    PorNome.AddEntry (Nome, SizeOf (Empregado), RecOffset);
    PorMatricula.AddEntry (Matricula, SizeOf (Empregado), RecOffset);
    PorSalario.AddEntry (Salario, SizeOf (Empregado), RecOffset);
    EmpPorDepto.AddEntry (Depto, SizeOf (Empregado), RecOffset);
    end;

{ Chega, n? }
TestRODB.DBClose (@AcompanhaSort);
Close;
end;

end.
